import numpy as np
from abc import ABC
from scipy.spatial.transform.rotation import Rotation as Rotation
from typing import Any

class DataModel(ABC): ...

class xyzd(DataModel):
    def __init__(self, data: np.ndarray) -> None: ...
    def get(self) -> np.ndarray: ...
    def translate_rotate(self, location: tuple[float, float, float], pitch_rads: Rotation) -> Any: ...
    def append(self, other: xyzd) -> bool: ...
    def __eq__(self, o: object) -> bool: ...

class PotentialCollisions(DataModel):
    def __init__(self, front: bool, back: bool, left: bool, right: bool) -> None: ...
    def get(self) -> tuple[bool, bool, bool, bool]: ...

class imu_data(DataModel):
    def __init__(self, altitude: float, dxdydz: tuple[float, float, float], yawpitchroll: tuple[float, float, float], heading: float) -> None: ...
    def get_altitude(self) -> float: ...
    def get_heading(self) -> float: ...
    def get_dxdydz(self) -> tuple[float, float, float]: ...
    def get_yawpitchroll(self) -> tuple[float, float, float]: ...

class speed_constraints(DataModel):
    def __init__(self, max_x: tuple[float, float], max_y: tuple[float, float], max_z: tuple[float, float]) -> None: ...
    def get_max_x(self) -> tuple[float, float]: ...
    def get_max_y(self) -> tuple[float, float]: ...
    def get_max_z(self) -> tuple[float, float]: ...
